function love.load()
	isStatsMode = false
	isGameOver = false
	LaserShot = love.audio.newSource("sounds/LaserShoot.wav")
	EnemyHurt = love.audio.newSource("sounds/EnemyHurt.wav")
	Screen = {
		Width = 470,
		Hight = 700,
	}
	
	Stats = {
		CannonFodderWidth = 47,
		lv2Width = 101,
		bossWidth = 137,
		shotWidth = 5,
		shotHeight = 15,
	}

	love.graphics.setBackgroundColor(150,150,255)
	success = love.window.setMode(Screen.Width, Screen.Hight)
	Player = love.graphics.newImage("graphics/theShip.png")
	Star = love.graphics.newImage("graphics/star.png")
	CannonFodder = love.graphics.newImage("graphics/cannonFodder.png")
	lv2 = love.graphics.newImage("graphics/lv2.png")
	boss = love.graphics.newImage("graphics/boss.png")
	enemyFire = love.graphics.newImage("graphics/enemyShot.png")
	playerFire = love.graphics.newImage("graphics/playerShot.png")
	LifeThree = love.graphics.newImage("graphics/three.png")
	LifeTwo = love.graphics.newImage("graphics/two.png")
	LifeOne = love.graphics.newImage("graphics/one.png")
	thePlayer = {
		lives = 3,
		StartHealth = 100,
		Health = 100,
		Forward = "w",
		Left = "a",
		Right = "d",
		Back = "s",
		Shoot = " ",
		Speed = 3,
		X = (Screen.Width - 85)/2,
		Y = (Screen.Hight - 85)/2,
	}
	
	Stars = {}
	Enemies = {}
	Shots = {}
	
	require "enemyStuff"
	require "starStuff"
	require "shoot"
	require "enemySpawning"
	
	spawningLoad()
end

local inGame = true
local newStarCount = 0

function toggleStatsMode()
	if isStatsMode == true then
		isStatsMode = false
	else
		isStatsMode = true
	end
end

function love.update(dt)
	spawningUpdate()
	if inGame == true then
		if love.keyboard.isDown(thePlayer.Forward) and thePlayer.Y > 0 then
			thePlayer.Y = thePlayer.Y - thePlayer.Speed
		elseif love.keyboard.isDown(thePlayer.Back) and thePlayer.Y < Screen.Hight - 85 then
			thePlayer.Y = thePlayer.Y + thePlayer.Speed
		end
		if love.keyboard.isDown(thePlayer.Left) and thePlayer.X > -42 then
			thePlayer.X = thePlayer.X - thePlayer.Speed
		elseif love.keyboard.isDown(thePlayer.Right) and thePlayer.X < Screen.Width - 42 then
			thePlayer.X = thePlayer.X + thePlayer.Speed
		end
		function love.keypressed(key)
			if key == "1" then
				newCannonFodder(love.math.random(Stats.CannonFodderWidth, Screen.Width - (Stats.CannonFodderWidth)), -100)
			elseif key == "2" then
				newLv2(love.math.random(Stats.lv2Width, Screen.Width - (Stats.lv2Width)), -100)
			elseif key == "3" then
				newBoss((Screen.Width/2) - Stats.bossWidth/2, 10)
			elseif key == " " then
				newBullet("player", thePlayer.X + 42, thePlayer.Y + 5)
			elseif key == "i" then
				toggleStatsMode()
			elseif key == "=" then
				WaveInfo.WaveNo = WaveInfo.WaveNo + 1
			elseif key == "-" then
				WaveInfo.WaveNo = WaveInfo.WaveNo - 1
			end
		end
	
		for i,v in ipairs(Stars) do
			v.y = v.y + v.Speed
			if v.y > Screen.Hight + 10 then
				table.remove(Stars, i)
			end
		end
	
		for i,v in ipairs(Shots) do
			if v.who == "player" then
				v.y = v.y - v.Speed
			else
				v.y = v.y + v.Speed
				if v.y > thePlayer.Y and v.y < thePlayer.Y + 85 then
					if v.x > thePlayer.X and v.x < thePlayer.X + 85 then
						table.remove(Shots, i)
						loseHealth(10)
					end
				end
			end
			
			if (v.y > Screen.Hight + 10) or (v.y < 0 - 10) then
				table.remove(Shots, i)
			end
		end
		
		
		newStarCount = newStarCount + 1
		if newStarCount > 8 then
			newStar()
			newStarCount = 0
		end
	
		for i,v in ipairs(Enemies) do
			for o,c in ipairs(Shots) do
				if c.who == "player" then
					if v.y+47 > c.y and v.y < c.y + 15 and (v.y + Stats.CannonFodderWidth) > 1 then
						if v.x+v.Width > c.x and v.x < c.x + 5 then
							v.Health = v.Health - 1
							table.remove(Shots, o)
						end
					end
				end
			end
			if v.y > (Screen.Width + 200) then
				table.remove(Enemies, i)
				gameOver()
			end
			if v.Health < 1 then
				table.remove(Enemies, i)
				EnemyHurt:play()
			end
			if v.Type == "CannonFodder" or v.Type == "Lv2" then
				v.ShootTimer = v.ShootTimer - 1
				if v.ShootTimer < 1 then
					if v.Type == "Lv2" then
						v.ShootTimer = love.math.random(1, 1000)
					elseif v.Type == "CannonFodder" then
						v.ShootTimer = love.math.random(1, 10000)
					end
					newBullet("enemy", v.x + (v.Width/2), v.y + 10)
				end
			end
			if v.Type == "Boss" then
				v.y = v.y + v.Speed
				v.SpawnCFtimer = v.SpawnCFtimer - 1
				v.SpawnLv2timer = v.SpawnLv2timer - 1
				if v.SpawnLv2timer < 1 then
					v.SpawnLv2timer = v.TimeSet
					newLv2(v.x + Stats.lv2Width*2, v.y)
					newLv2(v.x + Stats.lv2Width/2, v.y)
					newLv2(v.x - Stats.lv2Width/2, v.y)
					newLv2(v.x - Stats.lv2Width*2, v.y)
				elseif v.SpawnCFtimer < 1 then
					v.SpawnCFtimer = v.TimeSet
				end
			elseif v.Type == "Lv2" then
				v.y = v.y + v.Speed
			elseif v.Type == "CannonFodder" then
				if v.x > Screen.Width - v.Width then
					v.moving = "down"
				elseif v.x < 1 then
					v.moving = "down"
				end
				
				if v.moving == "down" then
					v.Downed = v.Downed + 1
					v.y = v.y + v.Speed
					if v.Downed > 15 then
						v.Downed = 0
						if v.x > Screen.Width - v.Width then
							v.moving = "left"
						elseif v.x < 1 then
							v.moving = "right"
						end
					end
				end
				
				if v.moving == "left" then
					v.x = v.x - v.Speed
				elseif v.moving == "right" then
					v.x = v.x + v.Speed
				end
			end
			
			if v.y > thePlayer.Y and v.y < thePlayer.Y + 85 then
				if v.x > thePlayer.X and v.x < thePlayer.X + 85 then
					table.remove(Enemies, i)
					loseHealth(10)
				end
			end
			
		end
	end
end

function losePlayerLife()
	thePlayer.lives = thePlayer.lives - 1
	if thePlayer.lives < 1 then
		gameOver()
	else
		thePlayer.Health = thePlayer.StartHealth
	end
end

function gameOver()
	toggleSpawning()
	clearEnemies()
	isGameOver = true
end

function loseHealth(toLose)
	thePlayer.Health = thePlayer.Health - toLose
	if thePlayer.Health < 1 then
		losePlayerLife()
	end
end

function love.draw()
	if isGameOver == false then
		if thePlayer.lives == 3 then
			love.graphics.draw(LifeThree, (Screen.Width/2)-15, 30)
			love.graphics.setColor(255,255,255,255)
		elseif thePlayer.lives == 2 then
			love.graphics.draw(LifeTwo, (Screen.Width/2)-15, 30)
			love.graphics.setColor(127,85,85,255)
		elseif thePlayer.lives == 1 then
			love.graphics.draw(LifeOne, (Screen.Width/2)-15, 30)
			love.graphics.setColor(255,0,0,255)
		end	
		love.graphics.rectangle("fill", 0, 0, thePlayer.Health*(Screen.Width/thePlayer.StartHealth), 25)
		
		love.graphics.setColor(255,255,255,255)
		
		for i,v in ipairs(Stars) do
			love.graphics.draw(Star, v.x, v.y)
		end
		
		for i,v in ipairs(Shots) do
			if v.who == "player" then
				love.graphics.draw(playerFire, v.x, v.y)
			else
				love.graphics.draw(enemyFire, v.x, v.y)
			end
		end
		
		if inGame == true then
			love.graphics.draw(Player, thePlayer.X, thePlayer.Y)
		end
		
		
		for i,v in ipairs(Enemies) do
			if v.Type == "CannonFodder" then
				love.graphics.draw(CannonFodder, v.x, v.y)
			elseif v.Type == "Lv2" then
				love.graphics.draw(lv2, v.x, v.y)
			elseif v.Type == "Boss" then
				love.graphics.draw(boss, v.x, v.y)
			end
		end
		spawningDraw()
	elseif isGameOver == true then
		love.graphics.setColor(0,0,0,255)
		love.graphics.rectangle("fill", 0, 0, Screen.Width, Screen.Hight)
		love.graphics.setColor(255,255,255,255)
	end
	if isStatsMode == true then
		love.graphics.setColor(0,0,0,255)
		love.graphics.print("Stats:\n" .. "Wave Delay: " .. WaveInfo.WaveDelayIn .. "\nWave Length: " .. WaveInfo.WaveLength .. "\nWave Number: " .. WaveInfo.WaveNo, 1, 1)
		love.graphics.setColor(255,255,255,255)
	end
end